=== src/acc/libsmm_acc/notebooks/requirements.txt ===
bokeh==1.0.4
matplotlib==3.0.2
numpy==1.16.0
pandas==0.23.4
pandas-profiling==1.4.1
seaborn==0.9.0
