=== debian/changelog ===
dbcsr (2.1.0-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Sun, 10 Jan 2021 13:35:14 +0100
