=== debian/control ===
Source: dbcsr
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 10),
               python3,
               gfortran,
               libblas-dev,
               liblapack-dev,
               mpi-default-bin,
               mpi-default-dev
Standards-Version: 4.1.0
Homepage: https://dbcsr.cp2k.org
Vcs-Browser: https://salsa.debian.org/debichem-team/dbcsr
Vcs-Git: https://salsa.debian.org/debichem-team/dbcsr.git

Package: libdbcsr-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Distributed Block Compressed Sparse Row matrix library
 DBCSR is a library designed to efficiently perform sparse matrix matrix
 multiplication, among other operations. It is MPI and OpenMP parallel.
