=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/mpi-default-dev/debian_defaults

DEB_BUILD_MULTIARCH?=$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

%:
	dh $@ --buildsystem=cmake

#override_dh_auto_configure:
#	dh_auto_configure -- \
#		-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/${DEB_BUILD_MULTIARCH}
