=== debian/watch ===
version=3
#opts=uversionmangle=s/(\d+)\.(\d+)\.(\d+)/$1.$2/ \
https://github.com/cp2k/dbcsr/releases .*/releases/download/v[\d.]+/dbcsr-([\d.]+)\.tar\.(?:bz2|gz)
