## dbcsr 2.3.0

=== debian/changelog ===
dbcsr (2.3.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/skip_failing_openmpi_rma_testcase.patch: Removed, no longer
    needed.

 -- Michael Banck <mbanck@debian.org>  Mon, 11 Jul 2022 09:20:16 +0200

dbcsr (2.2.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix_mod_install.patch: Refreshed.
  * debian/rules (override_dh_auto_test): New rule, force tests to run
    non-parallel.
  * debian/patches/skip_failing_openmpi_rma_testcase.patch: New patch, skips
    the MPI-RMA using testcase that fails with OpenMPI (Closes: #981831).

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Apr 2022 17:09:14 +0200
